Core - Task # 54525

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Story # 55078 (Closed): Optimize PHP code performance in TYPO3 methods

Status: Resolved Priority: Should have
Author: Michiel Roos Category: Performance
Created: 2013-12-20 Assigned To:

Updated: 2014-02-14 Due date:

TYPOS3 Version: 6.2

PHP Version: 5.3

Complexity: easy

Sprint Focus:

Subject: Optimize file- and path functions in GeneralUtility

Description

Optimize several frequently called methods:
- getFileAbsFileName()
- validPathStr()
- isAllowedAbsPath()
- verifyFilenameAgainstDenyPattern()

Associated revisions

Revision e1781feb - 2014-02-14 15:40 - Michiel Roos

[TASK] Optimize GeneralUtility path methods
The following methods are amongst the most frequently called ones:
- getFileAbsFileName()
- validPathStr()
- isAllowedAbsPath()
- verifyFilenameAgainstDenyPattern()

They can be optimized to return early, save some variable assignments and

save some preg_match calls.

Change-Id: I[d30b2f9b5a053d4267d9c24339f414821ba661ea
Resolves: #54525

Releases: 6.2

Reviewed-on: https:/review.typo3.org/26505

Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel
Reviewed-by: Stefan Neufeind
Reviewed-by: Markus Klein
Tested-by: Markus Klein

History

#1 - 2013-12-20 00:45 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
https://review.typo3.org/26505

It is available at https://review.typo3.org/26505

#2 - 2013-12-20 01:23 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#3 - 2013-12-20 01:26 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#4 - 2013-12-22 16:38 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#5 - 2014-01-08 23:40 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#6 - 2014-01-09 01:37 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#7 - 2014-01-09 10:36 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#8 - 2014-01-09 12:40 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/26505

#9 - 2014-01-09 14:11 - Georg Ringer

so what is the measured benefit?

#10 - 2014-01-09 15:14 - Michiel Roos

I'll post some stats this evening.
These methods are being called a lot during the frontend rendering and backend rendering. Parsing and concatenating JS and CSS and generating

cache files etc.

But to give you a rough impression. These are the current call counts for an uncached backend request (/typo3/backend.php), right after clearing all
cache:

Times are inclusive wall time.
TYPO3\CMS\Core\Utility\GeneralUtility::isAllowedAbsPath - 2.267 calls - 364,98 ms
TYPO3\CMS\Core\Utility\GeneralUtility::validPathStr - 2.315 calls - 168,77 ms
TYPO3\CMS\Core\Utility\GeneralUtility::isAbsPath -4.598 calls - 77,33 ms
TYPO3\CMS\Core\Utility\GeneralUtility::resolveBackPath - 608 calls - 23,03 ms

The total wall time was 10,43 s here . . . mostly taken by file_put_contents(), rename(), chgrp() etc.

Reduction in call times with the patch:
TYPO3\CMS\Core\Utility\GeneralUtility::isAllowedAbsPath - 67,30 ms
TYPO3\CMS\Core\Utility\GeneralUtility::validPathStr - 9,19 ms

TYPO3\CMS\Core\Utility\GeneralUtility::isAbsPath - 33,97 ms
TYPO3\CMS\Core\Utility\GeneralUtility::resolveBackPath - 2,32 ms

#11 - 2014-01-10 21:04 - Michiel Roos

Here is a test for the isAbsPath function to get an impression: http://pastebin.com/0BqyVGrc

#12 - 2014-01-28 10:05 - Ernesto Baschny
- Target version changed from next-patchlevel to 6.2.0
- Parent task set to #55078

#13 - 2014-02-06 14:11 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26505

#14 - 2014-02-06 15:08 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26505

#15 - 2014-02-07 17:39 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26505
#16 - 2014-02-13 11:48 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26505

#17 - 2014-02-14 12:59 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26505

#18 - 2014-02-14 16:30 - Michiel Roos
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:e1781feb954fa9208c604928d0943e1373b2f11c.
